//#include <msp430.h> //.h for part included in projec`t manually

#include "msp430fr6007.h"
#include "main.h"
#include "stdlib.h"


//constant arrays
char    MSG0[16] = " ENTER/SWIPE ID ";
//globals
char    msg1[16] = " ";  //for displays
char    msg2[16] = " ";
char    msg3[16] = " ";
char    msg4[16] = " ";
char    msg5[16] = " ";
char    msg6[16] = " ";
char    msg7[16] = " ";
char    msg8[16] = " ";
WORD    msecs = 0;
WORD    secmsec = 0;
WORD    msecs5 = 0;  //5 ms tick
WORD    many5s = 0;  //100ms tick
TIME    tm;
unsigned char    kbInOld = 0xF0;
unsigned char    kbIn = 0xF0;
unsigned char    kbEn = 0;
unsigned char    kbSameTicks = 0;
unsigned char    kbLoaded = 0;
unsigned char    kbBuf[20];
int     kbBufPos = 0;
unsigned char    kbBlock = 0;  //WNE SET (1) PREVENTS ADDITIONAL KEY STORAGE
unsigned char    swipeEn = 0;
unsigned char    crBitCtr = 0;
unsigned char    crBuf[90];
unsigned char    crPos = 0;
unsigned char    crBufPos = 0;
unsigned char    crEndFound = 1;  //normal is found
unsigned char    crErr = 0;
unsigned char    crEn = 0;
unsigned char    readyFlags = 0;
unsigned char    displayTimer = 0;
unsigned char    displayBuf[16];
int     beepTime = 0;
unsigned char    myAddress[2];
unsigned char    txBfr485[txBfr485Len];  //485 (main) com tx bfr size
unsigned char    rxBfr485[rxBfr485Len];  //485 com rx buffer size
int     tx4BfrLen;  //485 tx size for this message
int     rx4BfrLen;  //485 rx size for this message
int     lenCt; //a length count used by tx and rx routines
int     tx4BfrPos;  //current position in tx buffer
unsigned char    rxFlags = 0;  //for what is is rx buffer
int     beepOn = 0;  //lenght time beeper id on
int     beepOff = 0;  //length of time beeper is off between beeps
int     beepNum = 0;  //number of beeps
unsigned char    beepRun = 0;  //some beeping routine is running
int     locETB = -1;  //location of ETB in rx bfr
int     locEOT = -1;  //location of EOT in rx buffer
int     myn = 0;  //used in isr as test
int     myn1 = 0;  //sap
int     rxMsgLen = 0; //length of rx message
int     tick = 0;
unsigned char myTemp;
unsigned char crIn;
unsigned char dataField[5];
int bitCount = 0;
int nm;
int no;


/**
 * main.c
 *
 * note - the software runs WITHOUT the watch dog timer!!
 *
 * interrupts are KB, Swipe reader, uart, and 1 ms timer
 *
 */
void main(void)
{
	WDTCTL = WDTPW | WDTHOLD;	// stop watchdog timer
	_DINT();  //TURN OFF INTERRUPTS
	int mytest = BITF;
	
	init_micro();  //init things
	P8OUT |= TEST3;
	P8OUT &= ~TEST3; // TOGGLE TO MEASURE RESET TIME FROM COMCMD
	// For CRtests only
	P1IES  = CLS_ ;  //only CLS is neg edge int
	P1IE  = CLS_ | CRRCL;  //ints for cls and clock
	swipeEn = 1;  // turn on swipe read
	P1IFG = 0;

	_EINT();  //turn on interrupts but note that Swipe and  interrupts are not enabled locally
	          //so, at this point the only things on are the power fail, 1 ms timer, and uart interrupts

/**************
 *
 * Operational loop  - stays in loop until reset
 *
 * there is no particular order to checking things
 *
 ****************/

    while (1)
    {
        //1st, do kb stuff
        //scan is run in 5ms timer
        //READYs turned off when data sent

        if (P1IN & KBINT > 0)  //Pos & Ready should be zeroed when kb is enabled
        {
            if ((kbIn == kbInOld) && (kbSameTicks >= 3) && (kbLoaded > 0))
            {
                    switch (kbIn)
                    {
                    case 0xBE:  //clear key
                        kbBufPos = 0;
                        while (kbBufPos < 20)
                        {
                            kbBuf[kbBufPos++] = 0;
                        }
                        kbBufPos = 0;
                        kbLoaded = 0;  //get ready for next key
                        readyFlags &= ~(KBDATA | KBREADY);
                        beep(500, 0, 1);
                        kbBlock = 1;
                        //also clear display
                        break;
                    case 0xBD:  //zero key
                        kbBuf[kbBufPos++] = 0x30;  //ascii zero
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0x7E:  //1 key
                        kbBuf[kbBufPos++] = 0x31;  //ascii 1
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0x7D:  //2 key
                        kbBuf[kbBufPos++] = 0x32;  //ascii 2
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0x7B:  //3 key
                        kbBuf[kbBufPos++] = 0x33;  //ascii 3
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0xDE:  //4 key
                        kbBuf[kbBufPos++] = 0x34;  //ascii 4
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0xDD:  //5 key
                        kbBuf[kbBufPos++] = 0x35;  //ascii 5
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0xDB:  //6 key
                        kbBuf[kbBufPos++] = 0x36;  //ascii 6
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0xEE:  //7 key
                        kbBuf[kbBufPos++] = 0x37;  //ascii 7
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0xED:  //8 key
                        kbBuf[kbBufPos++] = 0x38;  //ascii 8
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0xEB:  //9 key
                        kbBuf[kbBufPos++] = 0x39;  //ascii 9
                        readyFlags |= KBDATA;
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    case 0xBB:  //enter key
                        kbBuf[kbBufPos++] = CR;
                        readyFlags |= KBREADY;  //ready to send
                        beep(500, 0, 1);
                        kbBlock = 1;
                        break;
                    }
            }
        }

        // comm
        //First - get message

        //1st status poll
        unsigned char bad;
        unsigned char data = 0;
        //int device = 0;
        char nakcode = 0x30;  //code to say the problem  =1 bad message format  =2 display message too long
        if ((rxFlags & EOTrxd) && (locEOT == 5) && (rxBfr485[0] == ENQ))  //must be status poll
        {   //commands are SS = status poll
            //             S0 = status response

            bad = ckStatus();
            if (bad == 0)
            {
                lenCt = BuildStatusResponse();
                tx4BfrLen = lenCt;  // len Ct a decrementing count of stuff sent
                sendResponse();  //rxMsgLen is 1 based

            }
            UCA0IE |= UCRXIE;  //urn rx int back on
            myn++;
        }

        if (((rxFlags & EOTrxd ) >0 ) && ((rxFlags & ETBrxd) > 0)) //add and not status poll
        {
        /*now all the others
         *
         * kb data poll = GG  response kb = GF
         * CR poll = GX  response CR = G0
         * Request Display Msg = EE Dvc = 05  Response = E5
         * Request Enable KB = EE Dvc = 07  Response = E0
         * Request Enable CR = EE Dvc = 08  Response = E0
         * Request Beep = EE Dvc 00  Response = E0
         * Request Reset = FF  Response = F0
         */

            short myCrc = getcrc(rxBfr485, rxMsgLen - 4, 1);
            short thisCrc = (rxBfr485[rxMsgLen - 3] << 8) | rxBfr485[rxMsgLen - 2];
            if (thisCrc == myCrc)
            {
                if ((rxFlags & EOTrxd) && (locEOT != 6) && (rxBfr485[0] == ENQ)
                        && (rxBfr485[AdIdx] = myAddress[0])  && (rxBfr485[AdIdx + 1] = myAddress[1]))  //other commands & our address
                {
                    int rpt;
                    int device = 0;
                    int command = (rxBfr485[CmdIdx] << 8) | rxBfr485[CmdIdx + 1];  //16 bit cmd string
                    switch (command)
                    {
                        case 0x4545:  // "EE" enable command needs device code
                            device = (rxBfr485[DvcIdx] << 8) | rxBfr485[DvcIdx + 1];  //16 bit device string

                            switch (device)
                            {
                            case 0x3030:  //"00" beeper

                                rpt= rxBfr485[DvcIdx + 2] & MASKINT;  //# REPEATS FOR NBEEP
                                int ont = (((rxBfr485[DvcIdx + 3] & MASKINT) * 10) + (rxBfr485[DvcIdx + 4] & MASKINT)) * 100; //ON TIME INNMS
                                int offt = (((rxBfr485[DvcIdx + 5] & MASKINT) * 10) + (rxBfr485[DvcIdx + 6] & MASKINT)) * 100; //OFF TIME IN MS
                                beep(rpt, ont, offt);
                                lenCt = BuildEEResponse(ACK, nakcode);  //lenCt is a decrementing count of stuff sent
                                tx4BfrLen = lenCt;
                                sendResponse();
                                UCA0IE |= UCRXIE;  //urn rx int back on
                                break;
                            case 0x3035:
                                bad = 0;
                                int pos = 0;
                                data = 0x30;  //just loading a non control character for testing
                                if (locEOT > DataIdx + 16 + 4)
                                {
                                    bad++;
                                    nakcode = 0x32;
                                }
                                while ((data >= 0x30) && (pos < 16))  //bails on a ctl char or 16 msg bytes
                                {
                                    data = rxBfr485 [DataIdx + pos];
                                    msg1[pos++] = data;
                                }
                                if (data != ETB)
                                {
                                    bad++;
                                    nakcode = 0x31;
                                    break;
                                }
                                if (nakcode > 0)
                                {
                                    lenCt = BuildEEResponse(NAK, nakcode);
                                    tx4BfrLen = lenCt;
                                    sendResponse();
                                    UCA0IE |= UCRXIE;  //urn rx int back on
                                    break;
                                }else


                                {
                                    lenCt = BuildEEResponse(NAK, nakcode);
                                    tx4BfrLen = lenCt;
                                    sendResponse();
                                    char disp[DispMax];
                                    int number2BSent = locEOT - 4 - DataIdx - 1;  // - 4 gets to last data character DataIdx - 1 gets rid of front
                                    int disppos = 0;
                                    while (disppos > number2BSent)
                                    {
                                        disp[disppos] = rxBfr485[DataIdx + disppos];
                                        disppos++;
                                    }
                                    loadDisp(disp, number2BSent);
                                    UCA0IE |= UCRXIE;  //urn rx int back on
                                    break;
                                }
                            case 0x3037:  //enable kb
                                kbEn = 1;
                                lenCt = BuildEEResponse(ACK, nakcode);
                                tx4BfrLen = lenCt;
                                sendResponse();
                                UCA0IE |= UCRXIE;  //urn rx int back on
                                break;
                            case 0x3038:  //enable cr
                                crEn = 1;
                                lenCt = BuildEEResponse(ACK, nakcode);
                                tx4BfrLen = lenCt;
                                sendResponse();
                                UCA0IE |= UCRXIE;  //urn rx int back on
                                break;
                            default:
                                nakcode = 1;
                                lenCt = BuildEEResponse(ACK, nakcode);
                                tx4BfrLen = lenCt;
                                sendResponse();
                                UCA0IE |= UCRXIE;  //urn rx int back on
                                break;
                            }  //sw device
                            break; //finished EE
                    case 0x4747:  // "GG" kb data poll
                        lenCt = BuildKBDataResponse();
                        tx4BfrLen = lenCt;
                        sendResponse();
                        UCA0IE |= UCRXIE;  //urn rx int back on
                        break;
                    case 0x4758:  //"GX"  cr data poll
                        lenCt = BuildCRDataResponse();
                        tx4BfrLen = lenCt;
                        sendResponse();
                        UCA0IE |= UCRXIE;  //urn rx int back on
                        break;
                    case 0x4646:  //reset
                        lenCt = BuildRSResponse();
                        tx4BfrLen = lenCt;
                        sendResponse();
                        tick = 0;
                        while (tick < 2)
                        {

                        }
                        WDTCTL = 0x0000;  //bad write to WDT causes power on reset
                        break;

                    }  //sw command
                }
            }
        }  //else do nothing bad crc
    }

}

int    BuildRSResponse(void)
{
    P4OUT |= TXrRX;  //TURN THE LINE AROUND
    P8OUT |= TEST3;  //FOR LOGIC ANAL

        int pos = 0;
        int n = 0;
        txBfr485[pos++] = STX;
        txBfr485[pos++] = myAddress[1];
        txBfr485[pos++] = myAddress[0];
        txBfr485[pos++] = 0x46;  //"F"
        txBfr485[pos++] = 0x30;
        txBfr485[pos++] = ACK;
        txBfr485[pos++] = ETB;
        short newcrc = getcrc(txBfr485, pos - 1, 1);
        unsigned char crc1 = newcrc >> 8;
        txBfr485[pos++] = crc1;
        unsigned char crc2 = newcrc & 0xFF;
        txBfr485[pos++] = crc2;
        txBfr485[pos++] = EOT;
        return pos;
}

int    BuildKBDataResponse(void)
{
    P4OUT |= TXrRX;  //TURN THE LINE AROUND
    P8OUT |= TEST3;  //FOR LOGIC ANAL

    int pos = 0;
    int n = 0;
    txBfr485[pos++] = STX;
    txBfr485[pos++] = myAddress[1];
    txBfr485[pos++] = myAddress[0];
    txBfr485[pos++] = 0x47;  //"G"
    txBfr485[pos++] = 0x46;
    while (n < kbBufPos);
    {
        txBfr485[pos++] = kbBuf[n++];
    }
    txBfr485[pos++] = ETB;
    short newcrc = getcrc(txBfr485, pos - 1, 1);
    unsigned char crc1 = newcrc >> 8;
    txBfr485[pos++] = crc1;
    unsigned char crc2 = newcrc & 0xFF;
    txBfr485[pos++] = crc2;
    txBfr485[pos++] = EOT;
    return pos;
}

int    BuildEEResponse(unsigned char rsp, unsigned char code)
{
    P4OUT |= TXrRX;  //TURN THE LINE AROUND
    P8OUT |= TEST3;  //FOR LOGIC ANAL
    int n = 0;

    clrBfr (txBfr485, txBfr485Len);
    txBfr485[n++] = STX;
    txBfr485[n++] = myAddress[1];
    txBfr485[n++] = myAddress[0];
    txBfr485[n++] = 0x45;  //"E"
    txBfr485[n++] = 0x30;
    txBfr485[n++] = rsp;
    if (rsp == NAK)
    {
        txBfr485[n++] = code;
    }
    txBfr485[n++] = ETB;
    short newcrc = getcrc(txBfr485, n - 1, 1);
    unsigned char crc1 = newcrc >> 8;
    txBfr485[n++] = crc1;
    unsigned char crc2 = newcrc & 0xFF;
    txBfr485[n++] = crc2;
    txBfr485[n++] = EOT;
    return n;
}

int    BuildCRDataResponse(void)
{
    P4OUT |= TXrRX;  //TURN THE LINE AROUND
    P8OUT |= TEST3;  //FOR LOGIC ANAL
    int pos = 0;
    int n = 0;
    txBfr485[pos++] = STX;
    txBfr485[pos++] = myAddress[1];
    txBfr485[pos++] = myAddress[0];
    txBfr485[pos++] = 0x47;  //"G"
    txBfr485[pos++] = 0x30;
    while (n < crBufPos);
    {
        txBfr485[pos++] = crBuf[n++];
    }
    txBfr485[pos++] = ETB;
    short newcrc = getcrc(txBfr485, pos - 1, 1);
    unsigned char crc1 = newcrc >> 8;
    txBfr485[pos++] = crc1;
    unsigned char crc2 = newcrc & 0xFF;
    txBfr485[pos++] = crc2;
    txBfr485[pos++] = EOT;
    return pos;

}

unsigned char ckStatus(void)
{
    int n = 0;
    unsigned char good = 0;
    unsigned char bad = 0;
    char check[4];
    check[0] = myAddress[1]; //ls char
    check[1] = myAddress[0];//ms char
    check[2] = 0x53;  //"S"
    check[3] = 0x53;
    for (n = 0; n <= 3; n++)
    {
        if (check[n] == rxBfr485[n+1])
        {
            good = 1;  //just a wasted line
        }else
        {
            bad = 1;
        }
    }
    if (bad > 0)
    {
        clrBfr(rxBfr485, 10);
    }
    return bad;
}

int    BuildStatusResponse(void)
{
    P4OUT |= TXrRX;  //TURN THE LINE AROUND
    P8OUT |= TEST3;  //FOR LOGIC ANAL
    int n = 0;
    unsigned char data = 0;
    clrBfr (txBfr485, txBfr485Len);
    txBfr485[n++] = STX;
    txBfr485[n++] = myAddress[1];
    txBfr485[n++] = myAddress[0];
    txBfr485[n++] = 0x53;  //"S"
    txBfr485[n++] = 0x30;
    if ((readyFlags & KBREADY) > 0)
    {
        data = 0x32;
    }
    if ((readyFlags & CRREADY) > 0)
    {
        data = 0x46;  //"F"

    }
    if (data == 0)
    {
        data = 0x31;  //normal and idle
    }
    txBfr485[n++] = data;
    txBfr485[n++] = 0x30;
    txBfr485[n++] = DEL;  //Reader Status Indicator which is useless
    txBfr485[n++] = ACK;
    txBfr485[n++] = ETB;
    short newcrc = getcrc(txBfr485, n - 1, 1);
    unsigned char crc1 = newcrc >> 8;
    txBfr485[n++] = crc1;
    unsigned char crc2 = newcrc & 0xFF;
    txBfr485[n++] = crc2;
    txBfr485[n++] = EOT;
    return n;

}

//Send an already built response to a poll usiing txBfr485
void    init_display(void)
{
    while (displayTimer < 26)  //wait 25 ms
    {
        __asm(" NOP ") ;
    }
    P4OUT &= ~(RS_ | LCDWrR);  //ser RS and R/Wn low
    P3OUT = 0x30;  //  1stnit
    sendStuff();
    while (displayTimer < 6)  //wait 4.1 ms
    {
        __asm(" NOP ") ;
    }
    //send same again
    sendStuff();
    while (displayTimer < 3)  //wait 1.1 ms
    {
        __asm(" NOP ") ;
    }
    //send same again
    sendStuff();
    msTime();

    //now complete sequence
    P3OUT = 0x10;  //set function type
    sendStuff();
    msTime();
    P3OUT = 0x08;  //display off
    sendStuff();
    msTime();
    P3OUT = 0x01;   //display clear
    sendStuff();
    msTime();
    P3OUT = 0x06;  //move cursor when char loaded and ready for data
    sendStuff();
    msTime();

    //load init msg MSG0
    loadDisp(MSG0, 16);


}


void    sendResponse(void)
{
    myn = 0;
    myn1 = 0;
    clrBfr(rxBfr485, rx4BfrLen);  //clear buffer to avoid processing it more than once
    rxMsgLen = 0;  //get ready for next message to be received
    rxFlags &= ~EOTrxd;
    rxFlags &= ~ETBrxd;  //clear rx flags

    UCA0IFG &= ~UCTXCPTIFG;  //make sure int flag is clear tp start
    tx4BfrPos = 0;  //starting point
    UCA0TXBUF = txBfr485[tx4BfrPos++];

    //the rest of the buffer char are sent in the interrupt service routine
    while ((lenCt - 1) > 0)
    {
        UCA0IE = UCTXIE;  //START SENDING

    }
}


/*===========================================================================
*
* Function: Port 1 Interupt
*
* Desc:    P1-1 is card read started neg edge
*          P1-4 is card reader clock neg edge
*          p1-7 is KBINT pos edgeare pulser inputs
*
* Parms:    none.
* Returns:  none.
*

---------------------------------------------------------------------------*/

#pragma vector=PORT1_VECTOR
__interrupt void Port1_int(void)
{


    if ((P1IFG & KBINT > 0)  && (kbEn > 0))  //KBINT
    {
        //start keyboard acquistion
        kbBufPos = 0;
        readyFlags &= ~(KBDATA | KBREADY);
        P1IE &= ~KBINT;  //turn off int on P1  runs on millisec timer
    }
    if (((P1IFG & CLS_) > 0) && (swipeEn > 0))  //swipe read started
    {
        P1IE &= ~CLS_;  //TURN OFF START INT
        P1IE |= CRRCL;  //TURN ON CLOCK INT NEG EDGE
        P1IFG &= ~CLS_;
        crIn = 0;
        crBitCtr = 0;
        crPos = 0;
        crEndFound = 0;
        bitCount = 0;
    }
    if (((P1IFG & CRRCL) > 0) && (swipeEn > 0))
    {

        nm = P1IES;
        no = P1IES & CRRCL;


        if (no == 0)
        {

            bitCount++;  //counting number of bits
            unsigned char crTemp = P1IN & CRRTD;
            dataField[crBitCtr] = crTemp;

            myTemp = crTemp;
            crTemp = crTemp >> (4 - crBitCtr);  //move bit to right position

            crIn |= crTemp;
            crBitCtr++;

            if ((crBitCtr >= 4) && (crEndFound == 0))
            {
                //ck parity
                unsigned char parityBit = (BIT0 & crIn) ^ (BIT0 & (crIn >>1)) ^ (BIT0 & (crIn >>2))
                    ^ (BIT0 & (crIn>>3)) ;  //needs odd parity************
                if (1)  //(parityBit == crIn>>4 )  //parity (odd) is good
                {
                    crBuf[crPos++] = crIn;  //(crIn & CRMASK) | 0x30;  //convert to ascii and store
                    if (crBuf[crPos-1] == (ENDSEN && 0x0F))
                    {
                        crEndFound = 1;
                    }

                }else
                {
                    crBuf[crPos++] = 0xFF;  //load error character
                    crErr = 1;  //found error
                }
                crBitCtr = 0;  //start next char
            }
            if ((crBitCtr > 4) && crEndFound)  //ch LRC
            {
                unsigned char pos = 0;
                unsigned char lrc = 0;

                while (pos < crPos)
                    {
                    lrc = lrc ^ crBuf[pos];
                    pos++;
                    }
                if (crIn == (lrc & CRMASK))
                    {
                        crBuf[crPos] = lrc | 0X30 ;  //CONVERTNTO ASCII AND STORE
                    }else
                    {
                        crBuf[crPos++] = 0xFF;  //load error character
                        crErr = 1;  //found error
                    }
                readyFlags |= CRREADY;  //set data ready to send whether good or bad
             }
            crBufPos = crPos;
            P1IES |= CRRCL;  //SET INTERRUPT EDGE TO HIGH TO LOW  THIS IS FOR DEBOUNCE OF CLOCK SIGNAL
        }

        if (P1IES & CRRCL > 0)  //delay to debounce clock interrupt
        {
            int nn = 0;
            while (nn < 20)
            {
                nn++;
            }
            P1IES &= ~CRRCL;  //set clock interrupt bck to hight to low
        }
        P1IFG &= CRRCL;  // CLEAR THE INT FLAG
    }
}

/*===========================================================================
*
* Function: TimerA0_int
*
* Desc:     This INTERRUPT polls the offhook switches every msec
*               has a debounce routine and sets offhook status for each side
*
*               Could also poll pulser at offhook = true for each side
*               This would reduce number of interrupts
*
* Parms:    none.
* Returns:  none.
*
---------------------------------------------------------------------------*/

#pragma vector=TIMER0_A0_VECTOR
__interrupt void TIMER0_A0_int(void)

{

  ++msecs;                // this interupt occurs every millisec increments counter each time
   ++msecs5;               // can use this as another polling timer
   ++secmsec;
   displayTimer++;
   tick++;  //a delay fr reset command
   PJOUT |= TEST1;  //to check timing
   PJOUT &= TEST1;


  if (msecs5 == 5)
  {
    msecs5 = 0;
    many5s++;

    if ((kbEn > 0)  && ((P1IN & KBINT) == 0))  //scan kb or turn off scan
    {
        if (kbInOld == 0)
        {
            kbBlock = 0;
        }
        switch (P6OUT)
        {
        case 0x0F:
            P6OUT = 0x0E;
            break;
        case 0x0E:
            P6OUT = 0xD;
            break;
        case 0x0D:
            P6OUT = 0x0B;
            break;
        case 0x0B:
            P6OUT = 0x07;
            break;
        case 0x7F:
            P6OUT = 0X0e;
            break;
        }
    }else if (kbEn == 0) //turn SCAN off
    {
        P6OUT = 0x0F;
    }
    if (P1IN & KBINT > 0)  // store old KBINT state
    {
        kbInOld = 1;
    }else
    {
        kbInOld = 1;
    }
  }

  if (many5s == 20)
  {
      many5s = 0;
      if (beepRun > 0)
      {
          if (beepTime <= 0)
          {
              beepTime -= 100;
          }
      }
      if ((beepTime <= 0) && (beepNum > 0))
      {
          if (((P4OUT & BEEP) > 0) && (beepNum > 0))  //is it time to turn off beeper? if so, do it
          {
              P4OUT &= ~BEEP;  //TURN OFF
              beepTime = beepOff;  //set time for time off
          }
          if (((P4OUT & BEEP) == 0) && (beepNum > 0))  //is it time to turn on beeper? if so, do it
          {
              if (beepNum > 1)  //if the previos beep was not the last one
              {
                  P4OUT &= BEEP;  //turn beeper on
                  beepTime = beepOn;
              }
              beepNum--;  //decrement count
              if (beepNum == 0)
              {
                  beepRun = 0;  //turn run off
              }
          }
      }

  }

  if (secmsec == 1000)
  {
      secmsec = 0;

          if (++tm.secs == 60)
          {
              tm.secs = 0;

              if (++tm.mins == 60)
              {
                  tm.mins = 0;

                  if (++tm.hrs == 24)
                      tm.hrs = 0;
              }
          }
  }

  kbIn = P6IN & KBINMASK;
  if (kbIn == kbInOld)
  {
      if(kbSameTicks <= 0xF)  //if more than 15, don't increment anymore
      {
          kbSameTicks++;
          kbLoaded = 1;  //set for new key to be stored
      }
  }else  //kb data changed so start kbSave timer again
  {
      kbSameTicks = 0;
      kbLoaded = 0;  //reset the key loaded indicator if it was set.
  }


  TA0CCTL0 &= ~CCIFG;
  TA0CTL &= ~TAIFG;  // clear interrupts

}

void    msTime(void)
{
    int theTime = 0;
    while (theTime < 250)  //about 1ms
    {}
}

void    tenthTime(void)
{
    int theTime = 0;  //about 0.1 ms
    while (theTime < 25);

}

void    sendStuff(void)
{
    P4OUT &= ~LCDEN_;  //strobe enable
    tenthTime();
    P4OUT |= LCDEN_;
    displayTimer = 0;  //clr timer

}

void    beep(int lenOn, int lenOff, int num)
{
    beepOn = lenOn;
    beepOff = lenOff;
    beepNum = num;
    beepRun = 1;
    beepTime = lenOn;
    P1OUT  |= BEEP;
}
/*===========================================================================
*
* Function: ckBusy
*
* Desc:   check busy flag on display
*
* Parms:    none.
* Returns:  none.
*
---------------------------------------------------------------------------*/
void    ckBusy(void)
{
    //not sure I need this
}


/*===========================================================================
*
* Function: init_display
*
* Desc:   Setup display inputs and outputs, 8 bits
*
* Parms:    none.
* Returns:  none.
*
---------------------------------------------------------------------------*/
void    loadDisp(char bfr[], int posmax)
{
    unsigned char    pos = 0;
        while (pos < posmax)
        {
            P3OUT = bfr[pos];
            sendStuff();
            msTime();
            pos++;
        }

}

/*===========================================================================
*
* Function: init_micro
*
* Desc:   Setup micro inputs and outputs, serial channels, clocks, A/Ds and interupts
*
* Parms:    none.
* Returns:  none.
*
---------------------------------------------------------------------------*/
void    init_micro(void)
{
    WDTCTL = WDTPW + WDTHOLD;       // Stop WDT interrupt
       PMMCTL0 = 0XA540;  //UNLOCK PMM REGS

       PM5CTL0 = ~LOCKLPM5;  //turn on io port config ability
       UCA0CTLW0 = 0X00E1;              // hold in reset to setup

 /*      UCA1BRW  = 0x0004;          // 57,600 based on 4 MHz clock
       UCA1MCTLW = 0x5551;              // 57,600 based on 4 MHz clock

            // init main registors  do port selection first for hfxtl
       FRCTL0 = 0xA501;  //setwrite protect for FR memory       */

       // Set up port J  ok

   PJSEL0 = 0xC0;          // BITS 4 & 5 ARE IO
   PJSEL1 = 0x00;
   PJDIR = 0x30;           // all outputs (not used)
   PJOUT = 0x00;           // initial output state all low



       //CLOCK  ok

       CSCTL0 = 0xA500;  //set password to change clock registers

       CSCTL4 = 0xC001;  //HF ON, HIGH DRIVE, OTHE OSCS OFF

       CSCTL2 = 0x0055;  //HF USED FOR ALL CLOCKS

       CSCTL3 = 0x0000;  //DIV BY 1 ON ALL CLOCKS

       int m = 0;  //wait for clock to stabilize
      /* while (m < 1000)
       {
           m++;
       }

       CSCTL5 &= ~HFXTOFFG;  // RESET FAULTS
       */
       do
        {
          CSCTL5 &= ~(LFXTOFFG | HFXTOFFG);       // Clear XT1 and XT2 fault flag
          SFRIFG1 &= ~OFIFG;
        }while (CSCTL5 & HFXTOFFG);                   // Test oscillator fault flag

            // init io ports

       P1SEL0 = 0x0D;
       P1SEL1 = 0x01;
        P1DIR = 0x20 ;   //**++ for testing only, P1 bit 1 is an output for time testing

    //++  need int now    P1IE  = 0x00;           // initial interrupts disabled (offhook setup for polling 1 msec)
        P1IES  = CLS_ | CRRCL;        // edge seLect  cls_ neg, crrcl neg, kbint pos
        P1OUT = 0x00;           // initial output state all low

        P1IFG = 0;  //TRYING TO CLEAR INT FLAGS
        P1IE = 0x00;  //kb int and cls*  no ints to start  only later

            // Set up port 2  ok

        P2SEL0 = 0x00;          // all pins are I/O
        P2SEL1 = 0x00;
        P2DIR = 0xFF;           // all outputs
        P2IE  = 0x00;           // interrupts disabled
        P2OUT = 0x00;           // initial output state

            // Set up port 3  ok

        P3SEL0 = 0x00;
        P3SEL1 = 0x00;
        P3DIR = 0xFF;
        P3OUT = 0x00;           // initial output state all low


            // Set up port 4  ok

        P4SEL0 = 0x18;           // all pins are I/O xcept bit 3 - 4  uart
        P4SEL1 = 0x00;
        P4DIR = 0xEF;           // bit 4 is rxd
        P4OUT = 0x4B;

            // port 5  OK

        P5DIR = 0xFF;
        P5SEL0 = 0x00;
        P5SEL1 = 0x30;
        P5OUT = 0x00;

            // PORT 6  OK

        P6DIR = 0x0F;
        P6SEL1 = 0x00;
        P6SEL0 = 0x00;
        P6OUT = 0x00;

            // PORT 7  ok

        P7DIR = 0xFF;
        P7SEL1 = 0x00;
        P7SEL0 = 0x03;
        P7OUT = 0x00;

           // PORT 8  ok

        P8DIR = 0xFF;
        P8SEL1 = 0x00;
        P8SEL0 = 0x60;
        P8OUT = 0x60;

            //port 9  ok
        P9DIR = 0x00;
        P9SEL1 = 0x00;
        P9SEL0 = 0x00;
        P9OUT = 0x00;


        // init uarts RS485  ok

        //UCTL0 = 0x01;
        UCA0CTLW0 = 0X00E1;              // hold in reset to setup
        unsigned char speed = P9IN & (SPEED0 | SPEED1);

        switch (speed)
        {
        case 0:  //19.2 kbs
            UCA0BRW = 0x01A;
            UCA0MCTLW = 0xB601;
            break;

        case 1:  //38.4 kbs
            UCA0BRW = 0x00D;
            UCA0MCTLW = 0x8401;
            break;

        case 2:  //57.6 KBS
            UCA0BRW = 0x008;
            UCA0MCTLW = 0xF7A1;
            break;

        case 3:  //115.2 KBS
            UCA0BRW = 0x004;
            UCA0MCTLW = 0x5551;
            break;

        }

        UCA0CTLW0 = 0X00E0;                 // Initialize USART0 state machine (~SWRST) release reset
        UCA0IE = UCRXIE;                  // Enable usart RX interrupt (ONLY rx)


            // init timers ok

        TA0CTL   = 0x0212;            // SMCLK, count up to TACCR0 (CCR0), clear timer, enable interrupt
        TA0CCTL0 = 0x0010;  //enable compare int
        TA0CCR0  = 0x1F40;          // 1 msec interrupt   8000 BASE 10
        TA0CCTL1 = 0;
        TA0CCTL2 = 0;
        TA0R = 0x0001 ; //  start timer


    //++ Set up comparator
    CECTL0 = 0x0303;  // + input ch 15 and - input VREF
    CECTL1 = 0x155C ;  //++  comp on, normal mode, output filtered, falling edge int
    CECTL2 = 0x0404 ;  //++  vfref to - term, 1.2 v ref, ref shared
    //CEINT = 0x0100 ;  // int on

    //get address in ascii

     unsigned char   addressRaw = P5IN & ADMASK;
     addressRaw++; //switcges are zero based but address is 1 based
     if (addressRaw >= 0x0A)
     {
         myAddress[0] = (addressRaw - 0x0A) | 0x30;  //generate ls address char
         myAddress[1] = 0x31;  //gen ms address char
     }else
     {
         myAddress[0] = addressRaw | 0x30;  //generate ls address char
         myAddress[1] = 0x30;  // ms address char
     }
}


    //now do comm






/*===========================================================================
*
* Function: uarta0_int
*
* Desc:     RS485 (Main comm) interrupt
*
* ++NOTE:  This interrupt can occur with the start of a new message while processing
*          the one just received.  The buffer will be cleared when the message is processed
*          losing any additional characters already in the buffer.  Thus, the new message will
*          be rejected as a bad message because of the lack of STX in the first buffer location
*
* Parms:    none.
* Returns:  none.
*
---------------------------------------------------------------------------*/
#pragma vector=EUSCI_A0_VECTOR
__interrupt void uarta0_int(void)
{
    unsigned char thischar=0;
    UCA0IFG &= ~UCSTTIFG;  //CLEAR START BIT (BYTE?) INT FLAG WE ARE NOT USING IT
    if (((UCA0IFG & UCTXIFG) > 0)) //&& ((UCA0IE & UCRXIE) == 0)) //tx buf empty and NOT rx
    {
        UCA0IFG &= ~UCTXIFG;  //clr tx int flag
        if (tx4BfrPos < (tx4BfrLen ))
        {
            UCA0IE |= UCTXIE;  //make sure int enable on
            thischar = txBfr485[tx4BfrPos];

            myn1++;
            UCA0TXBUF = txBfr485[tx4BfrPos++];  //load next char
            lenCt--;  //decrement lenCt

        }else  //end of transmit
        {
            UCA0IE &= ~UCTXIE;  //turn off tx bfr empty int
            //UCA0IE |= UCTXCPTIE;  //turn on shift reg empty in
            myn = 0;
            while (myn < 500)
            {
                myn++;
            }

            P4OUT &= ~TXrRX;  //go back to receive mode
            P8OUT &= ~TEST3;


            //UCA0IFG &= ~UCTXCPTIFG;  //make sure int flag is clear tp start

        }
    /*
        if (((UCA0IFG & UCTXCPTIFG) > 0) && ((UCA0IE & UCTXCPTIE) > 0))
    {
        //UCA0IFG &= ~UCTXCPTIFG;  //clr int
        UCA0IE &= ~UCTXCPTIE;  // turn off shift reg empty int
       // P4OUT &= ~TXrRX;  //go back to receive mode
    }
    */
    }
    if ((UCA0IFG & UCRXIFG) > 0)  //receive
    {
        unsigned char data = UCA0RXBUF;
        if (data == ENQ)
        {
            rx4BfrLen = clrBfr (rxBfr485, rxBfr485Len);  //clears buf and sets position to 0  ENQ is start of new msg
        }
        rxBfr485[rx4BfrLen++] = data;  //load rx char  clears int

        if (data == ETB)
        {
            rxFlags |= ETBrxd;
            locETB = rx4BfrLen - 1;
        }
        if (data == EOT)
        {
            rxFlags |= EOTrxd;
            locEOT = rx4BfrLen - 1;
            rxMsgLen = rx4BfrLen;  // set receive msg length
        }

        if ((rx4BfrLen > rxBfr485Len) || (rxBfr485[0] != ENQ)) //this is an error msg is too long) or 1st char not enq
        {
            clrBfr(rxBfr485, rx4BfrLen);  //clears buf and sets position to 0
        }
    }
}

    // cleaar a unsigned char buiffer
int clrBfr (unsigned char buf[], int len)

{
    int n = 0;
    for (n = 0; n < len; n++)
    {
        buf[n] = 0;  //clearing array
    }
    len = 0;  //reset position counter
    return len;
}

/*===========================================================================
*
* Module:   CRC.C
*
* Desc:     Calculate CRC for given command/response.
*
*
---------------------------------------------------------------------------*/

/* Polynominal X^16 + X^15 + X^2 + 1 */

//#include "main.h"


unsigned char crcArray[75] = { 0 };




const unsigned short CRCtab[256] = {
        0x0000, 0xc0c1, 0xc181, 0x0140, 0xc301, 0x03c0, 0x0280, 0xc241,
        0xc601, 0x06c0, 0x0780, 0xc741, 0x0500, 0xc5c1, 0xc481, 0x0440,
        0xcc01, 0x0cc0, 0x0d80, 0xcd41, 0x0f00, 0xcfc1, 0xce81, 0x0e40,
        0x0a00, 0xcac1, 0xcb81, 0x0b40, 0xc901, 0x09c0, 0x0880, 0xc841,
        0xd801, 0x18c0, 0x1980, 0xd941, 0x1b00, 0xdbc1, 0xda81, 0x1a40,
        0x1e00, 0xdec1, 0xdf81, 0x1f40, 0xdd01, 0x1dc0, 0x1c80, 0xdc41,
        0x1400, 0xd4c1, 0xd581, 0x1540, 0xd701, 0x17c0, 0x1680, 0xd641,
        0xd201, 0x12c0, 0x1380, 0xd341, 0x1100, 0xd1c1, 0xd081, 0x1040,
        0xf001, 0x30c0, 0x3180, 0xf141, 0x3300, 0xf3c1, 0xf281, 0x3240,
        0x3600, 0xf6c1, 0xf781, 0x3740, 0xf501, 0x35c0, 0x3480, 0xf441,
        0x3c00, 0xfcc1, 0xfd81, 0x3d40, 0xff01, 0x3fc0, 0x3e80, 0xfe41,
        0xfa01, 0x3ac0, 0x3b80, 0xfb41, 0x3900, 0xf9c1, 0xf881, 0x3840,
        0x2800, 0xe8c1, 0xe981, 0x2940, 0xeb01, 0x2bc0, 0x2a80, 0xea41,
        0xee01, 0x2ec0, 0x2f80, 0xef41, 0x2d00, 0xedc1, 0xec81, 0x2c40,
        0xe401, 0x24c0, 0x2580, 0xe541, 0x2700, 0xe7c1, 0xe681, 0x2640,
        0x2200, 0xe2c1, 0xe381, 0x2340, 0xe101, 0x21c0, 0x2080, 0xe041,
        0xa001, 0x60c0, 0x6180, 0xa141, 0x6300, 0xa3c1, 0xa281, 0x6240,
        0x6600, 0xa6c1, 0xa781, 0x6740, 0xa501, 0x65c0, 0x6480, 0xa441,
        0x6c00, 0xacc1, 0xad81, 0x6d40, 0xaf01, 0x6fc0, 0x6e80, 0xae41,
        0xaa01, 0x6ac0, 0x6b80, 0xab41, 0x6900, 0xa9c1, 0xa881, 0x6840,
        0x7800, 0xb8c1, 0xb981, 0x7940, 0xbb01, 0x7bc0, 0x7a80, 0xba41,
        0xbe01, 0x7ec0, 0x7f80, 0xbf41, 0x7d00, 0xbdc1, 0xbc81, 0x7c40,
        0xb401, 0x74c0, 0x7580, 0xb541, 0x7700, 0xb7c1, 0xb681, 0x7640,
        0x7200, 0xb2c1, 0xb381, 0x7340, 0xb101, 0x71c0, 0x7080, 0xb041,
        0x5000, 0x90c1, 0x9181, 0x5140, 0x9301, 0x53c0, 0x5280, 0x9241,
        0x9601, 0x56c0, 0x5780, 0x9741, 0x5500, 0x95c1, 0x9481, 0x5440,
        0x9c01, 0x5cc0, 0x5d80, 0x9d41, 0x5f00, 0x9fc1, 0x9e81, 0x5e40,
        0x5a00, 0x9ac1, 0x9b81, 0x5b40, 0x9901, 0x59c0, 0x5880, 0x9841,
        0x8801, 0x48c0, 0x4980, 0x8941, 0x4b00, 0x8bc1, 0x8a81, 0x4a40,
        0x4e00, 0x8ec1, 0x8f81, 0x4f40, 0x8d01, 0x4dc0, 0x4c80, 0x8c41,
        0x4400, 0x84c1, 0x8581, 0x4540, 0x8701, 0x47c0, 0x4680, 0x8641,
        0x8201, 0x42c0, 0x4380, 0x8341, 0x4100, 0x81c1, 0x8081, 0x4040};

/* Polynomial X^16 + X^12 + X^5 + 1 */
/*
unsigned short CCITTtab[256] = {
        0x0000, 0x1021, 0x2042, 0x3063, 0x4084, 0x50a5, 0x60c6, 0x70e7,
        0x8108, 0x9129, 0xa14a, 0xb16b, 0xc18c, 0xd1ad, 0xe1ce, 0xf1ef,
        0x1231, 0x0210, 0x3273, 0x2252, 0x52b5, 0x4294, 0x72f7, 0x62d6,
        0x9339, 0x8318, 0xb37b, 0xa35a, 0xd3bd, 0xc39c, 0xf3ff, 0xe3de,
        0x2462, 0x3443, 0x420,  0x1401, 0x64e6, 0x74c7, 0x44a4, 0x5485,
        0xa56a, 0xb54b, 0x8528, 0x9509, 0xe5ee, 0xf5cf, 0xc5ac, 0xd58d,
        0x3653, 0x2672, 0x1611, 0x0630, 0x76d7, 0x66f6, 0x5695, 0x46b4,
        0xb75b, 0xa77a, 0x9719, 0x8738, 0xf7df, 0xe7fe, 0xd79d, 0xc7bc,
        0x48c4, 0x58e5, 0x6886, 0x78a7, 0x0840, 0x1861, 0x2802, 0x3823,
        0xc9cc, 0xd9ed, 0xe98e, 0xf9af, 0x8948, 0x9969, 0xa90a, 0xb92b,
        0x5af5, 0x4ad4, 0x7ab7, 0x6a96, 0x1a71, 0x0a50, 0x3a33, 0x2a12,
        0xdbfd, 0xcbdc, 0xfbbf, 0xeb9e, 0x9b79, 0x8b58, 0xbb3b, 0xab1a,
        0x6ca6, 0x7c87, 0x4ce4, 0x5cc5, 0x2c22, 0x3c03, 0x0c60, 0x1c41,
        0xedae, 0xfd8f, 0xcdec, 0xddcd, 0xad2a, 0xbd0b, 0x8d68, 0x9d49,
        0x7e97, 0x6eb6, 0x5ed5, 0x4ef4, 0x3e13, 0x2e32, 0x1e51, 0x0e70,
        0xff9f, 0xefbe, 0xdfdd, 0xcffc, 0xbf1b, 0xaf3a, 0x9f59, 0x8f78,
        0x9188, 0x81a9, 0xb1ca, 0xa1eb, 0xd10c, 0xc12d, 0xf14e, 0xe16f,
        0x1080, 0x00a1, 0x30c2, 0x20e3, 0x5004, 0x4025, 0x7046, 0x6067,
        0x83b9, 0x9398, 0xa3fb, 0xb3da, 0xc33d, 0xd31c, 0xe37f, 0xf35e,
        0x02b1, 0x1290, 0x22f3, 0x32d2, 0x4235, 0x5214, 0x6277, 0x7256,
        0xb5ea, 0xa5cb, 0x95a8, 0x8589, 0xf56e, 0xe54f, 0xd52c, 0xc50d,
        0x34e2, 0x24c3, 0x14a0, 0x0481, 0x7466, 0x6447, 0x5424, 0x4405,
        0xa7db, 0xb7fa, 0x8799, 0x97b8, 0xe75f, 0xf77e, 0xc71d, 0xd73c,
        0x26d3, 0x36f2, 0x0691, 0x16b0, 0x6657, 0x7676, 0x4615, 0x5634,
        0xd94c, 0xc96d, 0xf90e, 0xe92f, 0x99c8, 0x89e9, 0xb98a, 0xa9ab,
        0x5844, 0x4865, 0x7806, 0x6827, 0x18c0, 0x08e1, 0x3882, 0x28a3,
        0xcb7d, 0xdb5c, 0xeb3f, 0xfb1e, 0x8bf9, 0x9bd8, 0xabbb, 0xbb9a,
        0x4a75, 0x5a54, 0x6a37, 0x7a16, 0x0af1, 0x1ad0, 0x2ab3, 0x3a92,
        0xfd2e, 0xed0f, 0xdd6c, 0xcd4d, 0xbdaa, 0xad8b, 0x9de8, 0x8dc9,
        0x7c26, 0x6c07, 0x5c64, 0x4c45, 0x3ca2, 0x2c83, 0x1ce0, 0x0cc1,
        0xef1f, 0xff3e, 0xcf5d, 0xdf7c, 0xaf9b, 0xbfba, 0x8fd9, 0x9ff8,
        0x6e17, 0x7e36, 0x4e55, 0x5e74, 0x2e93, 0x3eb2, 0x0ed1, 0x1ef0};
*/

/*===========================================================================
*
* Function: getcrc
*
* Desc:     Calculate CRC
*
* Parms:    Buffer for calculation.
*           Number of bytes.
*           Seed value (May be anything or be 1 the first time routine is called.  All other
*           times the seed value will be the value returned from this routine.)
* Returns:  CRC.
*
---------------------------------------------------------------------------*/
unsigned short getcrc(unsigned char bfr[], short flen, unsigned short s)
{
//
    short          w;
    unsigned char  c;


//  s = 1;
//++  this includes 1st char in crc

    for (w = 0 ; w <= flen ; w++ )
    {
        c = bfr[w];
        if (w == 6) //++for trouble shooting only
        {
            int sTest = s; // just a break point
        }
/*      s = CCITTtab[((s >> 8) ^ c) &0xFF] ^ (s << 8); */
        s = CRCtab[(s ^ c) & 0xFF] ^ (s >> 8);

    }

    return s;
}
